<html>
<head>
<title>OgreThreadDefinesBoost.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_2eb764d9bdb39175641ca6b4fa1c3066.html">Threading</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreThreadDefinesBoost.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreThreadDefinesBoost_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*-------------------------------------------------------------------------</span>
<a name="l00002"></a>00002 <span class="comment">This source file is a part of OGRE</span>
<a name="l00003"></a>00003 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00004"></a>00004 <span class="comment"></span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00009"></a>00009 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00010"></a>00010 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00011"></a>00011 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00012"></a>00012 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00013"></a>00013 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00016"></a>00016 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00017"></a>00017 <span class="comment"></span>
<a name="l00018"></a>00018 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00019"></a>00019 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00020"></a>00020 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00021"></a>00021 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00022"></a>00022 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00023"></a>00023 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00024"></a>00024 <span class="comment">THE SOFTWARE</span>
<a name="l00025"></a>00025 <span class="comment">-------------------------------------------------------------------------*/</span>
<a name="l00026"></a>00026 <span class="preprocessor">#ifndef __OgreThreadDefinesBoost_H__</span>
<a name="l00027"></a>00027 <span class="preprocessor"></span><span class="preprocessor">#define __OgreThreadDefinesBoost_H__</span>
<a name="l00028"></a>00028 <span class="preprocessor"></span>
<a name="l00029"></a><a class="code" href="OgreThreadDefinesBoost_8h.html#a18a523fad1f9e10324e1742865f562b7">00029</a> <span class="preprocessor">#define OGRE_AUTO_MUTEX mutable boost::recursive_mutex OGRE_AUTO_MUTEX_NAME;</span>
<a name="l00030"></a><a class="code" href="OgreThreadDefinesBoost_8h.html#ace4a3180018d84c5295b17251233abfb">00030</a> <span class="preprocessor"></span><span class="preprocessor">#define OGRE_LOCK_AUTO_MUTEX boost::recursive_mutex::scoped_lock ogreAutoMutexLock(OGRE_AUTO_MUTEX_NAME);</span>
<a name="l00031"></a><a class="code" href="OgreThreadDefinesBoost_8h.html#a2fb96ea8ad9700f804480d1d7f5d692d">00031</a> <span class="preprocessor"></span><span class="preprocessor">#define OGRE_MUTEX(name) mutable boost::recursive_mutex name;</span>
<a name="l00032"></a><a class="code" href="OgreThreadDefinesBoost_8h.html#ac853de57688aefaec88f75cd9e0ac388">00032</a> <span class="preprocessor"></span><span class="preprocessor">#define OGRE_STATIC_MUTEX(name) static boost::recursive_mutex name;</span>
<a name="l00033"></a><a class="code" href="OgreThreadDefinesBoost_8h.html#a042f108091bba675307acb915a71bfa9">00033</a> <span class="preprocessor"></span><span class="preprocessor">#define OGRE_STATIC_MUTEX_INSTANCE(name) boost::recursive_mutex name;</span>
<a name="l00034"></a><a class="code" href="OgreThreadDefinesBoost_8h.html#a8a4683cdaf73994ea7ec391c1ba82b60">00034</a> <span class="preprocessor"></span><span class="preprocessor">#define OGRE_LOCK_MUTEX(name) boost::recursive_mutex::scoped_lock ogrenameLock(name);</span>
<a name="l00035"></a><a class="code" href="OgreThreadDefinesBoost_8h.html#a39e611f7baf80408d740fce6a2502414">00035</a> <span class="preprocessor"></span><span class="preprocessor">#define OGRE_LOCK_MUTEX_NAMED(mutexName, lockName) boost::recursive_mutex::scoped_lock lockName(mutexName);</span>
<a name="l00036"></a>00036 <span class="preprocessor"></span><span class="comment">// like OGRE_AUTO_MUTEX but mutex held by pointer</span>
<a name="l00037"></a><a class="code" href="OgreThreadDefinesBoost_8h.html#ab0e8c6d123555d7447c38185a1b9105e">00037</a> <span class="preprocessor">#define OGRE_AUTO_SHARED_MUTEX mutable boost::recursive_mutex *OGRE_AUTO_MUTEX_NAME;</span>
<a name="l00038"></a><a class="code" href="OgreThreadDefinesBoost_8h.html#a062b6df8793a5440c06a9056ff1c8fe9">00038</a> <span class="preprocessor"></span><span class="preprocessor">#define OGRE_LOCK_AUTO_SHARED_MUTEX assert(OGRE_AUTO_MUTEX_NAME); boost::recursive_mutex::scoped_lock ogreAutoMutexLock(*OGRE_AUTO_MUTEX_NAME);</span>
<a name="l00039"></a><a class="code" href="OgreThreadDefinesBoost_8h.html#a9ea1b6f845efd15c581b914ac84b93a3">00039</a> <span class="preprocessor"></span><span class="preprocessor">#define OGRE_NEW_AUTO_SHARED_MUTEX assert(!OGRE_AUTO_MUTEX_NAME); OGRE_AUTO_MUTEX_NAME = new boost::recursive_mutex();</span>
<a name="l00040"></a><a class="code" href="OgreThreadDefinesBoost_8h.html#a8b873e0e48fc343f9553e1dc526ff6f3">00040</a> <span class="preprocessor"></span><span class="preprocessor">#define OGRE_DELETE_AUTO_SHARED_MUTEX assert(OGRE_AUTO_MUTEX_NAME); delete OGRE_AUTO_MUTEX_NAME;</span>
<a name="l00041"></a><a class="code" href="OgreThreadDefinesBoost_8h.html#acf02af48b9d015cd2f0c10e22466c73a">00041</a> <span class="preprocessor"></span><span class="preprocessor">#define OGRE_COPY_AUTO_SHARED_MUTEX(from) assert(!OGRE_AUTO_MUTEX_NAME); OGRE_AUTO_MUTEX_NAME = from;</span>
<a name="l00042"></a><a class="code" href="OgreThreadDefinesBoost_8h.html#a053475f75a35e320fa019cf083ba8918">00042</a> <span class="preprocessor"></span><span class="preprocessor">#define OGRE_SET_AUTO_SHARED_MUTEX_NULL OGRE_AUTO_MUTEX_NAME = 0;</span>
<a name="l00043"></a><a class="code" href="OgreThreadDefinesBoost_8h.html#a615a8a037a8f3290ec86ec0e376042b7">00043</a> <span class="preprocessor"></span><span class="preprocessor">#define OGRE_MUTEX_CONDITIONAL(mutex) if (mutex)</span>
<a name="l00044"></a><a class="code" href="OgreThreadDefinesBoost_8h.html#a792b8674a3579bf049e399dbfecf9f8b">00044</a> <span class="preprocessor"></span><span class="preprocessor">#define OGRE_THREAD_SYNCHRONISER(sync) boost::condition sync;</span>
<a name="l00045"></a><a class="code" href="OgreThreadDefinesBoost_8h.html#a2a5197ca265b2bfc25a5d0aa570d1f31">00045</a> <span class="preprocessor"></span><span class="preprocessor">#define OGRE_THREAD_WAIT(sync, mutex, lock) sync.wait(lock);</span>
<a name="l00046"></a><a class="code" href="OgreThreadDefinesBoost_8h.html#af95a22a8a787bbf4956772d36a0ccab5">00046</a> <span class="preprocessor"></span><span class="preprocessor">#define OGRE_THREAD_NOTIFY_ONE(sync) sync.notify_one(); </span>
<a name="l00047"></a><a class="code" href="OgreThreadDefinesBoost_8h.html#a15a4eee729a2c973782b3d65262b6c33">00047</a> <span class="preprocessor"></span><span class="preprocessor">#define OGRE_THREAD_NOTIFY_ALL(sync) sync.notify_all(); </span>
<a name="l00048"></a>00048 <span class="preprocessor"></span><span class="comment">// Read-write mutex</span>
<a name="l00049"></a><a class="code" href="OgreThreadDefinesBoost_8h.html#afd886be58b0d9b415076b07abfcc50fc">00049</a> <span class="preprocessor">#define OGRE_RW_MUTEX(name) mutable boost::shared_mutex name</span>
<a name="l00050"></a><a class="code" href="OgreThreadDefinesBoost_8h.html#a94e5c080fee840c4ee87132157cc3eda">00050</a> <span class="preprocessor"></span><span class="preprocessor">#define OGRE_LOCK_RW_MUTEX_READ(name) boost::shared_lock&lt;boost::shared_mutex&gt; ogrenameLock(name)</span>
<a name="l00051"></a><a class="code" href="OgreThreadDefinesBoost_8h.html#a0a38f532fc987f34e7ffa1d18b770fc9">00051</a> <span class="preprocessor"></span><span class="preprocessor">#define OGRE_LOCK_RW_MUTEX_WRITE(name) boost::unique_lock&lt;boost::shared_mutex&gt; ogrenameLock(name)</span>
<a name="l00052"></a>00052 <span class="preprocessor"></span><span class="comment">// Thread-local pointer</span>
<a name="l00053"></a><a class="code" href="OgreThreadDefinesBoost_8h.html#a7bbad1426a73ac69e63279b16e0f8ac4">00053</a> <span class="preprocessor">#define OGRE_THREAD_POINTER(T, var) boost::thread_specific_ptr&lt;T&gt; var</span>
<a name="l00054"></a><a class="code" href="OgreThreadDefinesBoost_8h.html#a7240ca4fa090f8e947dfa29be6580870">00054</a> <span class="preprocessor"></span><span class="preprocessor">#define OGRE_THREAD_POINTER_INIT(var) var(&amp;deletePtr)</span>
<a name="l00055"></a><a class="code" href="OgreThreadDefinesBoost_8h.html#aa0e31221f53cca1da4a1eaf196122a59">00055</a> <span class="preprocessor"></span><span class="preprocessor">#define OGRE_THREAD_POINTER_VAR(T, var) boost::thread_specific_ptr&lt;T&gt; var (&amp;deletePtr&lt;T&gt;)</span>
<a name="l00056"></a><a class="code" href="OgreThreadDefinesBoost_8h.html#ab2cf92160e83b716119c42240aad670f">00056</a> <span class="preprocessor"></span><span class="preprocessor">#define OGRE_THREAD_POINTER_SET(var, expr) var.reset(expr)</span>
<a name="l00057"></a><a class="code" href="OgreThreadDefinesBoost_8h.html#a5a4c5f6a9667046f955529291276f3dd">00057</a> <span class="preprocessor"></span><span class="preprocessor">#define OGRE_THREAD_POINTER_GET(var) var.get()</span>
<a name="l00058"></a><a class="code" href="OgreThreadDefinesBoost_8h.html#a9501d2980e624057c7701c0b3b539c3c">00058</a> <span class="preprocessor"></span><span class="preprocessor">#define OGRE_THREAD_POINTER_DELETE(var) var.reset(0)</span>
<a name="l00059"></a>00059 <span class="preprocessor"></span><span class="comment">// Thread objects and related functions</span>
<a name="l00060"></a><a class="code" href="OgreThreadDefinesBoost_8h.html#a215c480bf7f0aef85c342201319e256a">00060</a> <span class="preprocessor">#define OGRE_THREAD_TYPE boost::thread</span>
<a name="l00061"></a><a class="code" href="OgreThreadDefinesBoost_8h.html#a29238378cd8d5ec729999a09d2db45ef">00061</a> <span class="preprocessor"></span><span class="preprocessor">#define OGRE_THREAD_CREATE(name, worker) boost::thread* name = OGRE_NEW_T(boost::thread, MEMCATEGORY_GENERAL)(worker);</span>
<a name="l00062"></a><a class="code" href="OgreThreadDefinesBoost_8h.html#a67eae9d26fe65dd5c5e71a219789335c">00062</a> <span class="preprocessor"></span><span class="preprocessor">#define OGRE_THREAD_DESTROY(name) OGRE_DELETE_T(name, thread, MEMCATEGORY_GENERAL)</span>
<a name="l00063"></a><a class="code" href="OgreThreadDefinesBoost_8h.html#a736dde6a8a0eb784ed9d6988cbd56e5a">00063</a> <span class="preprocessor"></span><span class="preprocessor">#define OGRE_THREAD_HARDWARE_CONCURRENCY boost::thread::hardware_concurrency()</span>
<a name="l00064"></a><a class="code" href="OgreThreadDefinesBoost_8h.html#ab66207012917d8d514990e3ea4e54dcb">00064</a> <span class="preprocessor"></span><span class="preprocessor">#define OGRE_THREAD_CURRENT_ID boost::this_thread::get_id()</span>
<a name="l00065"></a><a class="code" href="OgreThreadDefinesBoost_8h.html#aa930d7a43e02d7c703548852a55036e1">00065</a> <span class="preprocessor"></span><span class="preprocessor">#define OGRE_THREAD_WORKER_INHERIT</span>
<a name="l00066"></a>00066 <span class="preprocessor"></span><span class="comment">// Utility</span>
<a name="l00067"></a><a class="code" href="OgreThreadDefinesBoost_8h.html#acb589a5397e0187e83e7337eb59e9881">00067</a> <span class="preprocessor">#define OGRE_THREAD_SLEEP(ms) boost::this_thread::sleep(boost::posix_time::millisec(ms));</span>
<a name="l00068"></a>00068 <span class="preprocessor"></span>
<a name="l00069"></a>00069 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:52
</p>
</body>
</html>
